/**
 *
 * @author Zhuplev Anton
 */
import java.io.*;
import java.util.*;



public class sol_zhuplev implements Runnable {


  private String input = "input.txt";
  private String output = "output.txt";
  private Scanner in = null;
  private PrintWriter out = null;
  private final int maxNumLength = 1000;
  private final int ansMod = 100*1000*1000 + 7;


  public sol_zhuplev() {
    try {
      in = new Scanner(new File(input));
      out = new PrintWriter(new File(output));
    } catch (Exception exept) {
      exept.printStackTrace();
      System.exit(1);
    }
  }


  public static void main(String[] args) {
    Locale.setDefault(Locale.US);
    new Thread(new sol_zhuplev()).start();
  }


  public void run() {
    try {
      solve();
    } catch (Exception exept) {
      exept.printStackTrace();
      System.exit(1);
    } finally {
      in.close();
      out.close();
    }
  }


  private void myAssert(boolean expr, String message) {
    if (!expr) {
      throw new Error("Assertion failure!!! " + message);
    }
  }


  int wcnt[] = new int[20];
  int ans[] = new int[maxNumLength + 1];
  String num;


  private int getDigit(int i) {
    return Integer.parseInt(Character.toString(num.charAt(i)));
  }


  @SuppressWarnings("unchecked")
  private void solve() {
    for (int i = 0; i < 10; i++) {
      for (int j = 0; j < 10; j++) {
        wcnt[i+j]++;
      }
    }

    num = in.next();
    myAssert(num.length() <= maxNumLength, "wrong number's length");
    num = "0".concat(num); ans[0] = 1;

    for (int i = 1; i < num.length(); i++) {
      ans[i] = (ans[i-1] * wcnt[getDigit(i)]) % ansMod;
      if (num.charAt(i-1) == '1') {
        ans[i] += ans[i-2] * wcnt[10 + getDigit(i)];
        ans[i] %= ansMod;
      }
    }

    out.print(ans[num.length()-1]);
  }
}
